/*
jGuard is a security framework based on top of jaas (java authentication and authorization security).
it is written for web applications, to resolve simply, access control problems.
version $Name:  $
http://sourceforge.net/projects/jguard/

Copyright (C) 2004  Charles GAY

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


jGuard project home page:
http://sourceforge.net/projects/jguard/

*/
package net.sf.jguard.ext;

import javax.naming.Context;
import javax.naming.ldap.LdapContext;

/**
 * Constants related to the net.sf.jguard.core package.
 * @author <a href="mailto:diabolo512@users.sourceforge.net">Charles GAY</a>
 */
public interface SecurityConstants {



//	public final static String APPLICATION_NAME = "applicationName";
//	public final static String DEBUG = "debug";
//	public final static String REQUIRED = "REQUIRED";
//	public final static String OPTIONAL = "OPTIONAL";
//	public final static String REQUISITE = "REQUISITE";
//	public final static String SUFFICIENT= "SUFFICIENT";
	public final static String AUTHENTICATION="authentication";
	public final static String AUTHORIZATION_PERMISSION_RESOLUTION_CACHING="permissionResolutionCaching";
	public final static String AUTHENTICATION_MANAGER="authenticationManager";
	public final static String AUTHENTICATION_MANAGER_OPTIONS="authenticationManagerOptions";
	public static final String AUTHENTICATION_DATABASE_FILE_LOCATION = "authenticationDatabaseFileLocation";
	public static final String AUTHENTICATION_JNDI_FILE_LOCATION = "authenticationJndiFileLocation";
	public static final String AUTHENTICATION_XML_FILE_LOCATION = "authenticationXmlFileLocation";
	public static final String AUTHORIZATION_DATABASE_FILE_LOCATION = "authorizationDatabaseFileLocation";
	public static final String AUTHORIZATION_XML_FILE_LOCATION = "authorizationXmlFileLocation";

	//database properties
	public final static String DATABASE_DRIVER="databaseDriver";
	public final static String DATABASE_DRIVER_URL="databaseDriverUrl";
	public final static String DATABASE_DRIVER_LOGIN="databaseDriverLogin";
	public final static String DATABASE_DRIVER_PASSWORD="databaseDriverPassword";

	//JNDI constants
	public final static String DIRECTORY_SEARCH_SCOPE ="directorySearchScope";
	public final static String DIRECTORY_COUNT_LIMIT ="directoryCountLimit";
	public final static String DIRECTORY_TIME_LIMIT ="directoryTimeLimit";
	public final static String DIRECTORY_DEREF_LINK_FLAG="directoryDerefLinkFlag";
	public final static String DIRECTORY_RETURNING_ATTRIBUTES="directoryReturningAttributes";
	public final static String DIRECTORY_RETURNING_OBJ_FLAG="directoryReturningObjFlag";
	public final static String DIRECTORY_SEARCH_CONTEXT_NAME="directorySearchContextName";
	public final static String DIRECTORY_SEARCH_FILTER_EXPRESSION="directorySearchFilterExpression";
	//JNDI "program" configuration
	//"java.naming.factory.initial"
	public final String INITIAL_CONTEXT_FACTORY =Context.INITIAL_CONTEXT_FACTORY;
	//"java.naming.factory.object"
	public final String OBJECT_FACTORIES = Context.OBJECT_FACTORIES;
	//"java.naming.factory.state"
	public final String STATE_FACTORIES = Context.STATE_FACTORIES;
	//"java.naming.factory.url.pkgs"
	public final String URL_PKG_PREFIXES= Context.URL_PKG_PREFIXES;
	//JNDI "access" configuration
	//"java.naming.provider.url"
	public final String PROVIDER_URL= Context.PROVIDER_URL;
	//"java.naming.dns.url"
	public final String DNS_URL= Context.DNS_URL;
	//JNDI "Service-related" configuration
	//"java.naming.authoritative"
	public final String AUTHORITATIVE= Context.AUTHORITATIVE;
	//"java.naming.batchsize"
	public final String BATCHSIZE=Context.BATCHSIZE;
	//"java.naming.referral"
	public final String REFERRAL= Context.REFERRAL;
	//JNDI "security" configuration
	//"java.naming.security.protocol"
	public final String SECURITY_PROTOCOL= Context.SECURITY_PROTOCOL;
	//"java.naming.security.authentication"
	public final String SECURITY_AUTHENTICATION= Context.SECURITY_AUTHENTICATION;
	//"java.naming.security.principal"
	public final String SECURITY_PRINCIPAL= Context.SECURITY_PRINCIPAL;
	//"java.naming.security.credentials"
	public final String SECURITY_CREDENTIALS= Context.SECURITY_CREDENTIALS;
	//JNDI "internationalisation" configuration
	//"java.naming.language"
	public final String LANGUAGE= Context.LANGUAGE;
	//JNDI "LDAP-related" program configuration
	//"java.naming.factory.control"
	public final String CONTROL_FACTORIES = LdapContext.CONTROL_FACTORIES;
	public final String LDAP_ATTRIBUTES_BINARY = "java.naming.ldap.attributes.binary";
	public final String LDAP_CONTROL_CONNECT ="java.naming.ldap.control.connect";
	public final String LDAP_DELETE_RDN ="java.naming.ldap.deleteRDN";
	public final String LDAP_DEREF_ALIASES="java.naming.ldap.derefAliases";
	public final String LDAP_FACTORY_SOCKET="java.naming.ldap.factory.socket";
	public final String LDAP_REF_SEPARATOR ="java.naming.ref.separator";
	public final String LDAP_REFERRAL_LIMIT ="java.naming.referral.limit";
	public final String LDAP_TYPESONLY ="java.naming.ldap.typesOnly";
	public final String LDAP_VERSION="java.naming.ldap.version";
	//JNDI LDAP SASL-related parameters
	public final String LDAP_SASL_AUTHORIZATION_ID ="java.naming.security.sasl.authorizationId";
	public final String LDAP_SASL_CALLBACK ="java.naming.sasl.callback";
	public final String LDAP_SASL_REALM ="java.naming.sasl.realm";
	public final String LDAP_SASL_QOP ="javax.naming.sasl.qop";
	public final String LDAP_SASL_STRENGTH="javax.security.sasl.strength";
	public final String LDAP_SASL_MAXBUFFER="javax.security.sasl.maxbuffer";
	public final String LDAP_SASL_SERVER_AUTHENTICATION="javax.security.sasl.server.authentication";
	public final String LDAP_SASL_POLICY_FORWARD ="javax.security.sasl.policy.forward";
	public final String LDAP_SASL_POLICY_CREDENTIALS="javax.security.sasl.policy.credentials";
	public final String LDAP_SASL_POLICY_NOPLAINTEXT="javax.security.sasl.policy.noplaintext";
	public final String LDAP_SASL_POLICY_NOACTIVE="javax.security.sasl.policy.noactive";
	public final String LDAP_SASL_NODICTIONARY="javax.security.sasl.policy.nodictionary";
	public final String LDAP_SASL_NOANONYMOUS="javax.security.sasl.policy.noanonymous";
	//CRL constants
	//certStore can be "LDAP" or "Collection"
	public final String CERT_PATH_CERTSTORE_TYPE = "certPathCertStoreType";
	public final String CERT_PATH_LDAP_SERVER_NAME ="certPathLdapServerName";
	public final String CERT_PATH_LDAP_SERVER_PORT ="certPathLdapServerPort";
	public final String CERT_PATH_CRL_DATE ="certPathCrlDate";
	public final String CERT_PATH_CRL_TIME_ZONE ="certPathCrlTimeZone";
	public final String CERT_PATH_CRL_LOCALE ="certPathCrlLocale";
	public final String CERT_PATH_ISSUER_NAMES ="certPathIssuerNames";
	public final String CERT_PATH_MIN_CRL_NUMBER ="certPathMinCrlNumber";
	public final String CERT_PATH_MAX_CRL_NUMBER ="certPathMaxCrlNumber";
	public final String CERT_PATH_CRL_PATH ="certPathCrlPath";
	public final String CERT_PATH_URL_CRL_PATH ="certPathUrlCrlPath";
	public final String CERT_PATH_ANY_POLICY_INHIBITED ="certPathAnyPolicyInhibited";
	public final String CERT_PATH_EXPLICIT_POLICY_REQUIRED ="certPathExplicitPolicyRequired";
	public final String CERT_PATH_POLICY_MAPPING_INHIBITED ="certPathPolicyMappingInhibited";
	public final String CERT_PATH_POLICY_QUALIFIERS_REJECTED ="certPathPolicyQualifiersRejected";
	public final String CERT_PATH_REVOCATION_ENABLED ="certPathRevocationEnabled";
	public final String CERT_PATH_SIG_PROVIDER ="certPathSigProvider";
	public final String CERT_STORE = "certStore";
	public final String SECURITY_PROVIDER ="securityProvider";
	public final String TRUSTED_CA_CERTIFICATES_DIRECTORY_PATH ="trustedCaCertsDirPath";
	public final static String PASSWORD_PROMPT = "passwordField";
	//fields names used in FORM authentication
	public final static String LOGIN_PROMPT = "loginField";
	//guest id
	public final static String GUEST = "guest";
	public final static String SECURED = "secured";
	public final static String APPLICATION_PASSWORD = "applicationPassword";

	public final static String AUTHORIZATION = "authorization";
	public final static String AUTHORIZATION_MANAGER = "authorizationManager";
	public final static String AUTHORIZATION_MANAGER_OPTIONS="authorizationManagerOptions";

	public final static String DIRECTORY_PATH_TO_USER ="directoryPathToUser";

//	public final static String INCLUDE_OLD_CONFIG = "includeOldConfig";
//	public final static String INCLUDE_CONFIG_FROM_JAVA_PARAM = "includeConfigFromJavaParam";
	public final static String INCLUDE_POLICY_FROM_JAVA_PARAM = "includePolicyFromJavaParam";
	public final static String ISSUER_CA_CERT_LOCATION = "IssuerCACertLocation";
	public final static String OCSP_SERVER_URL ="ocspServerURL";
	public final static String OCSP_SIGNER_CERT_LOCATION ="OcspSignerCertLocation";

	//constants for jGuardConfiguration.xml
	public static final String VALUE_MARKUP = "value";
	public static final String OPTION = "option";
//	public final static String LOGIN_MODULES= "loginModules";
	public static final String LOGIN_MODULE = "loginModule";
//	public static final String LOGIN_MODULE_OPTIONS = "loginModuleOptions";
//	public static final String FLAG = "flag";
//	public static final String NAME = "name";

	//system properties for SingleAppPolicy
	public static final String POLICY_CONFIGURATION_FILE="net.sf.jguard.policy.configuration.file";

	//constants for JCaptcha
	public static final String CAPTCHA_ANSWER="captchaAnswer";
	public static final String CAPTCHA_SERVICE="captchaService";

	public static final String COM_SUN_APPLICATION_NAME="com.sun.management.jmxremote.login.config";
	public static final String JGUARD_APPLICATION_NAME="net.sf.jguard.application.name";
//	public static final String DEFAULT_APPLICATION_NAME="other";

	// URLPermission protocols schemes
//	public static final String HTTP="http";
//	public static final String HTTPS="https";

	public static final String NEGATIVE_PERMISSIONS = "negativePermissions";

	//certificate constants
	public static final String UNIQUE_ID = "uniqueID";
	public static final String DN = "DN";
	public static final String PUBLIC_KEY = "publicKey";
	public static final String ALTERNATIVE_NAME = "alternativeName";

	public static final String SALT="salt";
	public static final String DIGEST_ALGORITHM = "digestAlgorithm";

}
