/*
jGuard is a security framework based on top of jaas (java authentication and authorization security).
it is written for web applications, to resolve simply, access control problems.
version $Name$
http://sourceforge.net/projects/jguard/

Copyright (C) 2004  Charles GAY

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


jGuard project home page:
http://sourceforge.net/projects/jguard/

*/
package net.sf.jguard.ext.audit;

import java.util.Iterator;
import java.util.logging.Logger;

import javax.security.auth.Subject;

import net.sf.jguard.core.authentication.credentials.JGuardCredential;

/**
 * regroups all accessControl Decisions.
 * @author <a href="mailto:diabolo512@users.sourceforge.net">Charles Gay</a>
 */
public class AuditManager {

	private static final Logger logger = Logger.getLogger(AuditManager.class.getName());


	   /**
	    * add an event to the AuditManager.
	    * @param user
	    * @param event
	    */
	   public static void addEvent(Subject user,Event event){
		   StringBuffer eventLog = new StringBuffer();
		   if(user!=null){
		    eventLog.append(" user= [ ");
		    Iterator it  = user.getPublicCredentials().iterator();
            while(it.hasNext()){
            	JGuardCredential cred = (JGuardCredential)it.next();
            	eventLog.append(" ").append(cred.getId());
            	eventLog.append("=");
            	eventLog.append(cred.getValue()).append(" ");
            }
             eventLog.append("]");
		   }else{
		    eventLog.append("user is null ");
		   }
		   eventLog.append(" : ").append(event.getCause());
		   eventLog.append(" implies ");
		   eventLog.append(event.getConsequence());
           logger.info(eventLog.toString());

	   }

	   /**
	    *
	    * @param user
	    * @param cause
	    * @param consequence
	    */
	   public static void addEvent(Subject user,String cause,String consequence){
		   Event event = new Event(cause,consequence);
		   addEvent(user,event);
	   }


}
